import type { _NSColor } from "./NSColor.js";
import type { _NSControl } from "./NSControl.js";
import type { _NSImage } from "./NSImage.js";
import type { _NSImageSymbolConfiguration } from "./NSImageSymbolConfiguration.js";
import type { _NSMenuItemValidation } from "./NSMenuItemValidation.js";
import type { _NSSymbolContentTransition } from "../Symbols/NSSymbolContentTransition.js";
import type { _NSSymbolEffect } from "../Symbols/NSSymbolEffect.js";
import type { _NSSymbolEffectOptions } from "../Symbols/NSSymbolEffectOptions.js";
import type { NSImageAlignment } from "./NSImageAlignment.js";
import type { NSImageDynamicRange } from "./NSImageDynamicRange.js";
import type { NSImageFrameStyle } from "./NSImageFrameStyle.js";
import type { NSImageScaling } from "./NSImageScaling.js";
export declare class _NSImageView extends _NSControl {
    static alloc(): _NSImageView;
    static new(): _NSImageView;
    init(): _NSImageView;
    /**
     * Creates a non-editable image view containing the provided image. The image is scaled proportionally down to fit the view, and is centered within the view. @param image The image to display within the view. @return An initialized image view.
     */
    static imageViewWithImage$(image: _NSImage): _NSImageView;
    /**
     * Default preferred image dynamic range. Defaults to `NSImageDynamicRangeConstrainedHigh` on macOS 14 and higher, `NSImageDynamicRangeStandard` otherwise. Set to another value to change the default for all subsequently created `NSImageView`s in your app.
     */
    static defaultPreferredImageDynamicRange(): NSImageDynamicRange;
    static setDefaultPreferredImageDynamicRange$(value: NSImageDynamicRange): void;
    /** Adds a symbol effect to the image view with default options and animation. */
    addSymbolEffect$(symbolEffect: _NSSymbolEffect): void;
    /**
     * Adds a symbol effect to the image view with specified options and default animation.
     */
    addSymbolEffect$options$(symbolEffect: _NSSymbolEffect, options: _NSSymbolEffectOptions): void;
    /** Adds a symbol effect to the image view with specified options and animation. */
    addSymbolEffect$options$animated$(symbolEffect: _NSSymbolEffect, options: _NSSymbolEffectOptions, animated: boolean): void;
    /**
     * Removes from the image view the symbol effect matching the type of effect passed in, with default options and animation.
     */
    removeSymbolEffectOfType$(symbolEffect: _NSSymbolEffect): void;
    /**
     * Removes from the image view the symbol effect matching the type of effect passed in, with specified options and default animation.
     */
    removeSymbolEffectOfType$options$(symbolEffect: _NSSymbolEffect, options: _NSSymbolEffectOptions): void;
    /**
     * Removes from the image view the symbol effect matching the type of effect passed in, with specified options and animation.
     */
    removeSymbolEffectOfType$options$animated$(symbolEffect: _NSSymbolEffect, options: _NSSymbolEffectOptions, animated: boolean): void;
    /**
     * Removes all symbol effects from the image view with default options and animation.
     */
    removeAllSymbolEffects(): void;
    /**
     * Removes all symbol effects from the image view with specified options and default animation.
     */
    removeAllSymbolEffectsWithOptions$(options: _NSSymbolEffectOptions): void;
    /**
     * Removes all symbol effects from the image view with specified options and animation.
     */
    removeAllSymbolEffectsWithOptions$animated$(options: _NSSymbolEffectOptions, animated: boolean): void;
    /**
     * Sets the symbol image on the image view with a symbol content transition and default options. Passing in a non-symbol image will result in undefined behavior.
     */
    setSymbolImage$withContentTransition$(symbolImage: _NSImage, transition: _NSSymbolContentTransition): void;
    /**
     * Sets the symbol image on the image view with a symbol content transition and specified options. Passing in a non-symbol image will result in undefined behavior.
     */
    setSymbolImage$withContentTransition$options$(symbolImage: _NSImage, transition: _NSSymbolContentTransition, options: _NSSymbolEffectOptions): void;
    image(): _NSImage | null;
    setImage$(value: _NSImage | null): void;
    editable(): boolean;
    setEditable$(value: boolean): void;
    imageAlignment(): NSImageAlignment;
    setImageAlignment$(value: NSImageAlignment): void;
    imageScaling(): NSImageScaling;
    setImageScaling$(value: NSImageScaling): void;
    imageFrameStyle(): NSImageFrameStyle;
    setImageFrameStyle$(value: NSImageFrameStyle): void;
    /**
     * Specifies a combination of point size, weight, and scale to use when sizing and displaying symbol images. If a symbol configuration isn't provided, the image view uses a default size, weight, and scale provided by the system. The default value is `nil`.
     */
    symbolConfiguration(): _NSImageSymbolConfiguration;
    setSymbolConfiguration$(value: _NSImageSymbolConfiguration): void;
    /**
     * A tint color to be used when rendering template image content. This color may be combined with other effects to produce a theme-appropriate rendition of the template image. A nil value indicates the standard set of effects without color modification. The default value is nil.
     */
    contentTintColor(): _NSColor;
    setContentTintColor$(value: _NSColor): void;
    animates(): boolean;
    setAnimates$(value: boolean): void;
    allowsCutCopyPaste(): boolean;
    setAllowsCutCopyPaste$(value: boolean): void;
    /** Preferred dynamic range when displaying an image in the receiving image view. */
    preferredImageDynamicRange(): NSImageDynamicRange;
    setPreferredImageDynamicRange$(value: NSImageDynamicRange): void;
    /**
     * Resolved dynamic range based on fully resolved image content. Note: this will return `NSImageDynamicRangeUnspecified` if the image view has not or can not resolve the content (either because it has no resolvable image content or has not resolved because the image view hasn't displayed.)
     */
    imageDynamicRange(): NSImageDynamicRange;
}
export interface _NSImageView extends _NSMenuItemValidation {
}
